/*  
 *  kill-cache.c - Вредный модуль включения/выключения процессорного кеша
 */
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#define DRIVER_AUTHOR "Roman I Khimov & Zhilyakov Andrey <khimov@osrc.info>"
#define DRIVER_DESC   "Useless module turning on/off x86 processor cache"

static int __init cache_off(void)
{
	printk(KERN_ALERT "Hello world and now we'll turn off your processor cache.\n");

	__asm__  ("movl %%cr0, %%eax\n"
		  "btsl $30, %%eax\n"
		  "movl %%eax, %%cr0\n":::"%eax"
	);

	printk(KERN_ALERT "We've just turned off your processor cache - enjoy :).\n");

	return 0;
}

static void __exit cache_on(void)
{
	__asm__  ("movl %%cr0, %%eax\n"
                  "btrl $30, %%eax\n"
                  "movl %%eax, %%cr0\n":::"%eax"
	);

	printk(KERN_ALERT "Processor cache turned on, module unloads.\n");

}

module_init(cache_off);
module_exit(cache_on);

MODULE_LICENSE("GPL");

MODULE_AUTHOR(DRIVER_AUTHOR);	/* Who wrote this module? */
MODULE_DESCRIPTION(DRIVER_DESC);	/* What does this module do */
